Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/tracinca_mod.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/tracinca_mod.F90	(revision 1191)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/tracinca_mod.F90	(revision 1191)
@@ -0,0 +1,191 @@
+!$Id $
+!
+MODULE tracinca_mod
+!
+! This module prepares and calls the INCA main subroutines. 
+!
+
+CONTAINS
+
+  SUBROUTINE tracinca_init(aerosol,lessivage)
+    ! This subroutine initialize some control varaibles. 
+
+    USE infotrac
+    IMPLICIT NONE
+    
+    ! Output variables
+    LOGICAL,DIMENSION(nbtr), INTENT(OUT) :: aerosol
+    LOGICAL,INTENT(OUT) :: lessivage
+    
+    
+    ! Initialization
+    lessivage  =.FALSE.
+    aerosol(:) = .FALSE.
+        
+  END SUBROUTINE tracinca_init
+
+  SUBROUTINE tracinca(                                &
+       nstep,    julien,   gmtime,         lafin,     &
+       pdtphys,  t_seri,   paprs,          pplay,     &
+       pmfu,     ftsol,    pctsrf,         pphis,     &
+       pphi,     albsol,   sh,             rh,        &
+       cldfra,   rneb,     diafra,         cldliq,    &
+       itop_con, ibas_con, pmflxr,         pmflxs,    &
+       prfl,     psfl,     aerosol_couple, flxmass_w, &
+       tau_aero, piz_aero, cg_aero,        ccm,       &
+       rfname,                                        &
+       tr_seri,  source,   solsym)      
+
+!========================================================
+!    -- CHIMIE INCA --
+!========================================================
+
+    USE dimphy
+    USE infotrac
+    USE vampir
+    USE comgeomphy
+    
+    IMPLICIT NONE
+    
+    INCLUDE "indicesol.h"
+    INCLUDE "control.h"
+    INCLUDE "dimensions.h"
+    INCLUDE "paramet.h"
+
+!==========================================================================
+!                   -- DESCRIPTION DES ARGUMENTS --
+!==========================================================================
+
+
+! EN ENTREE ...
+!
+!Configuration grille,temps:
+    INTEGER,INTENT(IN) :: nstep      ! Appel physique
+    INTEGER,INTENT(IN) :: julien     ! Jour julien
+    REAL,INTENT(IN)    :: gmtime
+    REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
+    LOGICAL,INTENT(IN) :: lafin      ! le flag de la fin de la physique
+    
+
+!Physique: 
+!--------
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: rh      ! humidite relative
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel
+    REAL,DIMENSION(klon),INTENT(IN)        :: pphis
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau liquide nuageuse
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldfra  ! fraction nuageuse (tous les nuages)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: rneb    ! fraction nuageuse (grande echelle)
+    INTEGER,DIMENSION(klon),INTENT(IN)     :: itop_con
+    INTEGER,DIMENSION(klon),INTENT(IN)     :: ibas_con
+    REAL,DIMENSION(klon),INTENT(IN)        :: albsol  ! albedo surface
+!
+!Convection:
+!----------
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: pmfu  ! flux de masse dans le panache montant
+
+!...Tiedke     
+    REAL,DIMENSION(klon,klev+1),INTENT(IN)   :: pmflxr, pmflxs ! Flux precipitant de pluie, neige aux interfaces [convection]
+    REAL,DIMENSION(klon,klev+1),INTENT(IN)   :: prfl, psfl ! Flux precipitant de pluie, neige aux interfaces [large-scale]
+
+    LOGICAL,INTENT(IN)                       :: aerosol_couple
+    REAL,DIMENSION(klon,klev),INTENT(IN)     :: flxmass_w
+    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: tau_aero
+    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: piz_aero
+    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: cg_aero
+    CHARACTER(len=4),DIMENSION(9),INTENT(IN) :: rfname 
+    REAL,DIMENSION(klon,klev,2),INTENT(IN)   :: ccm 
+
+! Arguments necessaires pour les sources et puits de traceur:
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: ftsol  ! Temperature du sol (surf)(Kelvin)
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: pctsrf ! Pourcentage de sol f(nature du sol)
+
+
+  ! InOutput argument
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT) :: tr_seri ! Concentration Traceur [U/KgA]  
+
+  ! Output arguments
+    REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
+    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
+
+!=======================================================================================
+!                        -- VARIABLES LOCALES TRACEURS --
+!=======================================================================================
+
+    INTEGER :: k
+    REAL,DIMENSION(klon,klev) :: pdel
+    REAL    :: calday
+    INTEGER :: ncsec
+
+    CALL VTe(VTphysiq)
+    CALL VTb(VTinca)
+    
+    calday = FLOAT(julien) + gmtime
+    ncsec  = NINT (86400.*gmtime)
+     
+    DO k = 1, klev
+       pdel(:,k) = paprs(:,k) - paprs (:,k+1)
+    END DO
+    
+    IF (config_inca == 'aero') THEN
+#ifdef INCA
+       CALL aerosolmain(                    &
+            aerosol_couple,tr_seri,pdtphys, &
+            pplay,pdel,prfl,pmflxr,psfl,    &
+            pmflxs,pmfu,itop_con,ibas_con,  &
+            pphi,airephy,nstep,rneb,t_seri, &      
+            rh,tau_aero,piz_aero,cg_aero,   &
+            rfname,ccm,lafin)
+#endif
+    END IF
+
+#ifdef INCA
+    CALL chemmain (tr_seri, &   !mmr
+         nstep,      & !nstep
+         calday,     & !calday
+         julien,     & !ncdate
+         ncsec,      & !ncsec
+         1,          & !lat
+         pdtphys,    & !delt
+         paprs(1,1), & !ps
+         pplay,      & !pmid
+         pdel,       & !pdel
+         airephy,    &
+         pctsrf(1,1),& !oro
+         ftsol,      & !tsurf
+         albsol,     & !albs
+         pphi,       & !zma
+         pphis,      & !phis
+         cldfra,     & !cldfr
+         rneb,       & !cldfr_st
+         diafra,     & !cldfr_cv
+         itop_con,   & !cldtop
+         ibas_con,   & !cldbot
+         cldliq,     & !cwat
+         prfl,       & !flxrst
+         pmflxr,     & !flxrcv
+         psfl,       & !flxsst
+         pmflxs,     & !flxscv
+         pmfu,       & !flxupd
+         flxmass_w,  & !flxmass_w
+         t_seri,     & !tfld
+         sh,         & !sh
+         rh,         & !rh
+         iip1,       & !nx
+         jjp1,       & !ny
+         source,     &
+         solsym)
+#endif
+    
+    CALL VTe(VTinca)
+    CALL VTb(VTphysiq)
+    
+    
+  END SUBROUTINE tracinca
+
+
+END MODULE tracinca_mod
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/traclmdz_mod.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/traclmdz_mod.F90	(revision 1191)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/traclmdz_mod.F90	(revision 1191)
@@ -0,0 +1,329 @@
+!$Id $
+!
+MODULE traclmdz_mod
+! 
+! In this module all tracers specific to LMDZ are treated. This module is used 
+! only if running without any other chemestry model as INCA or REPROBUS.  
+!
+
+  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: masktr   ! Masque reservoir de sol traceur
+!$OMP THREADPRIVATE(masktr)                        ! Masque de l'echange avec la surface (1 = reservoir) ou (possible >= 1 )
+  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: fshtr    ! Flux surfacique dans le reservoir de sol
+!$OMP THREADPRIVATE(fshtr)
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE   :: hsoltr   ! Epaisseur equivalente du reservoir de sol
+!$OMP THREADPRIVATE(hsoltr)
+!
+!Radioelements:
+!--------------
+!
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE   :: tautr    ! Constante de decroissance radioactive
+!$OMP THREADPRIVATE(tautr)
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE   :: vdeptr   ! Vitesse de depot sec dans la couche Brownienne
+!$OMP THREADPRIVATE(vdeptr)
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE   :: scavtr   ! Coefficient de lessivage
+!$OMP THREADPRIVATE(scavtr)
+  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: srcbe    ! Production du beryllium7 dans l atmosphere (U/s/kgA)
+!$OMP THREADPRIVATE(srcbe)
+
+  LOGICAL,DIMENSION(:),ALLOCATABLE,SAVE :: radio    ! radio(it)   = true  => decroisssance radioactive
+!$OMP THREADPRIVATE(radio)  
+
+  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: trs     ! Conc. radon ds le sol
+!$OMP THREADPRIVATE(trs)
+
+  INTEGER,SAVE :: id_be       ! Activation et position du traceur Be7 [ id_be=0 -> desactive ] 
+!$OMP THREADPRIVATE(id_be)
+
+  LOGICAL,SAVE :: rnpb=.TRUE. ! Presence du couple Rn222, Pb210
+!$OMP THREADPRIVATE(rnpb)
+
+
+CONTAINS
+
+  SUBROUTINE traclmdz_from_restart(trs_in)
+    ! This subroutine initialize the module saved variable trs with values from restart file (startphy.nc). 
+    ! This subroutine is called from phyetat0 after the field trs_in has been read.
+    
+    USE dimphy
+    USE infotrac
+    IMPLICIT NONE
+    
+    ! Input argument
+    REAL,DIMENSION(klon,nbtr), INTENT(IN) :: trs_in 
+    
+    ! Local variables
+    INTEGER :: ierr
+    
+    ! Allocate restart variables trs
+    ALLOCATE( trs(klon,nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('traclmdz_start', 'pb in allocation 1',1)
+    
+    ! Initialize trs with values read from restart file 
+    trs(:,:) = trs_in(:,:)
+    
+  END SUBROUTINE traclmdz_from_restart
+
+
+  SUBROUTINE traclmdz_init(pctsrf, ftsol, aerosol, lessivage)
+    ! This subroutine allocates and initialize module variables and control variables.
+    USE dimphy
+    USE infotrac
+
+    IMPLICIT NONE
+
+    INCLUDE "indicesol.h"
+
+! Input variables
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: pctsrf ! Pourcentage de sol f(nature du sol)
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: ftsol  ! Temperature du sol (surf)(Kelvin)
+    
+! Output variables
+    LOGICAL,DIMENSION(nbtr), INTENT(OUT) :: aerosol
+    LOGICAL,INTENT(OUT)                  :: lessivage
+        
+! Local variables    
+    INTEGER :: ierr, it, iiq
+    
+! --------------------------------------------
+! Allocation
+! --------------------------------------------
+
+    ALLOCATE( scavtr(nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 9',1)
+    scavtr(:)=1.
+    
+    ALLOCATE( radio(nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 11',1)
+    radio(:) = .false.    ! Par defaut pas decroissance radioactive
+    
+    ALLOCATE( masktr(klon,nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 2',1)
+    
+    ALLOCATE( fshtr(klon,nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 3',1)
+    
+    ALLOCATE( hsoltr(nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 4',1)
+    
+    ALLOCATE( tautr(nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 5',1)
+    tautr(:)  = 0.
+    
+    ALLOCATE( vdeptr(nbtr), stat=ierr)
+    IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 6',1)
+    vdeptr(:) = 0.
+
+
+    lessivage  = .TRUE.
+    aerosol(:) = .FALSE.  ! Tous les traceurs sont des gaz par defaut
+    
+!
+! Recherche des traceurs connus : Be7, CO2,...
+! --------------------------------------------
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       !
+       ! Recherche du Beryllium 7
+       !
+       IF ( tname(iiq) == "BE" .OR. tname(iiq) == "Be" .OR.  &
+            tname(iiq) == "BE7" .OR. tname(iiq) == "Be7" ) THEN  
+          id_be=it
+          ALLOCATE( srcbe(klon,klev) )
+          radio(id_be) = .TRUE.
+          aerosol(id_be) = .TRUE. ! le Be est un aerosol
+          CALL init_be(pctsrf,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
+          WRITE(*,*) 'Initialisation srcBe: OK'
+       ELSE
+          id_be=0
+       END IF
+       
+       ! Placer ici la recherche de nouveaux traceurs
+       ! ...
+    END DO
+!
+! Valeurs specifiques pour les traceurs Rn222 et Pb210
+! ----------------------------------------------
+    IF (rnpb) THEN
+        
+       radio(1)= .TRUE.
+       radio(2)= .TRUE.
+       pbl_flg(1) = 0 ! au lieu de clsol=true ! CL au sol calcule
+       pbl_flg(2) = 0 ! au lieu de clsol=true
+       
+       aerosol(2) = .TRUE. ! le Pb est un aerosol
+       
+       CALL initrrnpb (ftsol,pctsrf,masktr,fshtr,hsoltr,tautr,vdeptr,scavtr)
+    END IF
+
+  END SUBROUTINE traclmdz_init
+
+  SUBROUTINE traclmdz(                           &
+       pdtphys,  t_seri,                         &
+       paprs,    pplay,        cdragh,  coefh,   &
+       yu1,      yv1,          ftsol,   pctsrf,  &
+       xlat,     couchelimite,                   &
+       tr_seri,  source,       solsym,  d_tr_cl)
+    
+    USE dimphy
+    USE infotrac
+    
+    IMPLICIT NONE
+    
+    INCLUDE "YOMCST.h"
+    INCLUDE "indicesol.h"
+
+!==========================================================================
+!                   -- DESCRIPTION DES ARGUMENTS --
+!==========================================================================
+
+! Input arguments
+!
+!Configuration grille,temps:
+    REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)  
+    REAL,DIMENSION(klon),INTENT(IN) :: xlat    ! latitudes pour chaque point 
+
+!
+!Physique: 
+!--------
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+
+
+!Couche limite:
+!--------------
+!
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: cdragh     ! coeff drag pour T et Q
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: coefh      ! coeff melange CL (m**2/s)
+    REAL,DIMENSION(klon),INTENT(IN)      :: yu1        ! vents au premier niveau
+    REAL,DIMENSION(klon),INTENT(IN)      :: yv1        ! vents au premier niveau
+    LOGICAL,INTENT(IN)                   :: couchelimite
+
+! Arguments necessaires pour les sources et puits de traceur:
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: ftsol  ! Temperature du sol (surf)(Kelvin)
+    REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: pctsrf ! Pourcentage de sol f(nature du sol)
+
+! InOutput argument
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]  
+
+! Output argument
+    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
+    REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
+    REAL,DIMENSION(klon,klev,nbtr), INTENT(OUT)   :: d_tr_cl ! Td couche limite/traceur
+
+
+!=======================================================================================
+!                        -- VARIABLES LOCALES TRACEURS --
+!=======================================================================================
+
+    INTEGER :: i, k, it
+  
+
+    REAL,DIMENSION(klon)           :: d_trs    ! Td dans le reservoir
+    REAL,DIMENSION(klon,klev)      :: delp     ! epaisseur de couche (Pa)
+    
+    REAL,DIMENSION(klon,klev,nbtr) :: d_tr_dec ! Td radioactive
+    REAL                           :: zrho      ! Masse Volumique de l'air KgA/m3
+
+!
+!
+!=================================================================
+!  Ajout de la production en  Be7 (Beryllium) srcbe U/s/kgA
+!=================================================================
+!
+    IF ( id_be /= 0 ) THEN
+       DO k = 1, klev
+          DO i = 1, klon
+             tr_seri(i,k,id_be) = tr_seri(i,k,id_be)+srcbe(i,k)*pdtphys
+          END DO
+       END DO
+       WRITE(*,*) 'Ajout srcBe dans tr_seri: OK'
+    END IF
+  
+
+    DO it=1,nbtr
+       WRITE(solsym(it),'(i2)') it
+    END DO
+!======================================================================
+!     -- Calcul de l'effet de la couche limite --
+!======================================================================
+
+    IF (couchelimite) THEN             
+       DO it=1, nbtr
+          IF ( it == id_be ) THEN
+             DO i=1, klon
+                zrho = pplay(i,1)/t_seri(i,1)/RD
+                source(i,it) = - vdeptr(it)*tr_seri(i,1,it)*zrho
+             END DO
+          ELSE
+             source(:,it) = 0.0  
+          END IF
+       END DO
+    END IF
+    
+
+    DO k = 1, klev
+       DO i = 1, klon
+          delp(i,k) = paprs(i,k)-paprs(i,k+1)
+       END DO
+    END DO
+    
+    DO it=1, nbtr
+       IF (couchelimite .AND. pbl_flg(it) == 0 ) THEN ! couche limite avec quantite dans le sol calculee
+          CALL cltracrn(it, pdtphys, yu1, yv1,     &
+               cdragh, coefh,t_seri,ftsol,pctsrf,  &
+               tr_seri(:,:,it),trs(:,it),          &
+               paprs, pplay, delp,                 &
+               masktr(:,it),fshtr(:,it),hsoltr(it),&
+               tautr(it),vdeptr(it),               &
+               xlat,d_tr_cl(:,:,it),d_trs)
+          
+          DO k = 1, klev
+             DO i = 1, klon
+                tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cl(i,k,it)
+             END DO
+          END DO
+        
+          ! Traceur dans le reservoir sol
+          DO i = 1, klon
+             trs(i,it) = trs(i,it) + d_trs(i)
+          END DO
+       END IF
+    END DO
+           
+!======================================================================
+!   Calcul de l'effet du puits radioactif
+!======================================================================
+    CALL radio_decay (radio,rnpb,pdtphys,tautr,tr_seri,d_tr_dec)
+  
+    DO it=1,nbtr
+       IF(radio(it)) then     
+          DO k = 1, klev
+             DO i = 1, klon
+                tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_dec(i,k,it)
+             END DO
+          END DO
+          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'puits rn it='//solsym(it))
+       END IF
+    END DO
+    
+
+  END SUBROUTINE traclmdz
+
+
+  SUBROUTINE traclmdz_to_restart(trs_out)
+    ! This subroutine is called from phyredem.F where the module 
+    ! variable trs is written to restart file (restartphy.nc)
+    USE dimphy
+    USE infotrac
+    
+    IMPLICIT NONE
+    
+    REAL,DIMENSION(klon,nbtr), INTENT(OUT) :: trs_out
+    
+    trs_out(:,:) = trs(:,:)
+    
+  END SUBROUTINE traclmdz_to_restart
+  
+
+END MODULE traclmdz_mod
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/write_histrac.h
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/write_histrac.h	(revision 1190)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/write_histrac.h	(revision 1191)
@@ -1,83 +1,85 @@
+!$Id $
+!***************************************
+!  ECRITURE DU FICHIER :  histrac.nc
+!***************************************
+#ifdef CPP_IOIPSL
+  IF (ecrit_tra > 0. .AND. config_inca == 'none') THEN
+     
+     itau_w = itau_phy + nstep
+     
+     CALL histwrite_phy(nid_tra,"phis",itau_w,pphis)
+     CALL histwrite_phy(nid_tra,"aire",itau_w,airephy)
+
+!TRACEURS
+!----------------
+     DO it=1,nbtr
+        iiq=niadv(it+2)
+
+! CONCENTRATIONS
+        CALL histwrite_phy(nid_tra,tname(iiq),itau_w,tr_seri(:,:,it))
+
+! TD LESSIVAGE       
+        IF (lessivage .AND. aerosol(it)) THEN
+           CALL histwrite_phy(nid_tra,"fl"//tname(iiq),itau_w,flestottr(:,:,it))
+        ENDIF
+
+! TD THERMIQUES
+        IF (iflag_thermals.gt.0) THEN
+           CALL histwrite_phy(nid_tra,"d_tr_th_"//tname(iiq),itau_w,d_tr_th(:,:,it))
+        ENDIF
+
+! TD CONVECTION
+        IF (iflag_con.GE.2) THEN
+           CALL histwrite_phy(nid_tra,"d_tr_cv_"//tname(iiq),itau_w,d_tr_cv(:,:,it))
+        ENDIF
+
+! TD COUCHE-LIMITE
+        CALL histwrite_phy(nid_tra,"d_tr_cl_"//tname(iiq),itau_w,d_tr_cl(:,:,it))
+     ENDDO
+!---------------
 !
-! $Header$
 !
+! VENT (niveau 1)   
+     CALL histwrite_phy(nid_tra,"pyu1",itau_w,yu1)
+     CALL histwrite_phy(nid_tra,"pyv1",itau_w,yv1)
+!
+! TEMPERATURE DU SOL
+     zx_tmp_fi2d(:)=ftsol(:,1)         
+     CALL histwrite_phy(nid_tra,"ftsol1",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=ftsol(:,2)
+     CALL histwrite_phy(nid_tra,"ftsol2",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=ftsol(:,3)
+     CALL histwrite_phy(nid_tra,"ftsol3",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=ftsol(:,4)
+     CALL histwrite_phy(nid_tra,"ftsol4",itau_w,zx_tmp_fi2d)
+!      
+! NATURE DU SOL
+     zx_tmp_fi2d(:)=pctsrf(:,1)
+     CALL histwrite_phy(nid_tra,"psrf1",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=pctsrf(:,2)
+     CALL histwrite_phy(nid_tra,"psrf2",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=pctsrf(:,3)
+     CALL histwrite_phy(nid_tra,"psrf3",itau_w,zx_tmp_fi2d)
+     zx_tmp_fi2d(:)=pctsrf(:,4)
+     CALL histwrite_phy(nid_tra,"psrf4",itau_w,zx_tmp_fi2d)
+ 
+! DIVERS    
+     CALL histwrite_phy(nid_tra,"pplay",itau_w,pplay)     
+     CALL histwrite_phy(nid_tra,"t",itau_w,t_seri)     
+     CALL histwrite_phy(nid_tra,"mfu",itau_w,pmfu)
+     CALL histwrite_phy(nid_tra,"mfd",itau_w,pmfd)
+     CALL histwrite_phy(nid_tra,"en_u",itau_w,pen_u)
+     CALL histwrite_phy(nid_tra,"en_d",itau_w,pen_d)
+     CALL histwrite_phy(nid_tra,"de_d",itau_w,pde_d)
+     CALL histwrite_phy(nid_tra,"de_u",itau_w,pde_u)
+     CALL histwrite_phy(nid_tra,"coefh",itau_w,coefh)
 
-      IF (ecrit_tra>0. .AND. config_inca == 'none') THEN
-      ndex = 0
-      ndex2d = 0
-      ndex3d = 0
-c
-      itau_w = itau_phy + nstep
+     IF (ok_sync) THEN
+!$OMP MASTER
+        CALL histsync(nid_tra)
+!$OMP END MASTER
+     ENDIF
 
-      CALL histwrite_phy(nid_tra,"phis",itau_w,pphis)
-C
-      CALL histwrite_phy(nid_tra,"aire",itau_w,airephy)
+  ENDIF !ecrit_tra>0. .AND. config_inca == 'none'
 
-      DO it=1,nbtr
-       iiq=niadv(it+2)
-
-       CALL histwrite_phy(nid_tra,tname(iiq),itau_w,tr_seri(:,:,it))
-       if (lessivage) THEN
-       CALL histwrite_phy(nid_tra,"fl"//tname(iiq),itau_w,
-     .                                   flestottr(:,:,it))
-      endif
-      
-c----Olivia
-       CALL histwrite_phy(nid_tra,"d_tr_th_"//tname(iiq),itau_w,
-     .                                           d_tr_th(:,:,it))
-
-         if(iflag_con.GE.2) then
-       CALL histwrite_phy(nid_tra,"d_tr_cv_"//tname(iiq),itau_w,
-     .                                           d_tr_cv(:,:,it))
-         endif !(iflag_con.GE.2) then
-       CALL histwrite_phy(nid_tra,"d_tr_cl_"//tname(iiq),itau_w,
-     .                                           d_tr_cl(:,:,it))
-c---fin Olivia      
-      
-      ENDDO
-
-
-C abder
-         CALL histwrite_phy(nid_tra,"pyu1",itau_w,yu1)
-
-         CALL histwrite_phy(nid_tra,"pyv1",itau_w,yv1)
-
-         CALL histwrite_phy(nid_tra,"ftsol1",itau_w,pftsol1)
-
-         CALL histwrite_phy(nid_tra,"ftsol2",itau_w,pftsol2)
-
-         CALL histwrite_phy(nid_tra,"ftsol3",itau_w,pftsol3)
-
-         CALL histwrite_phy(nid_tra,"ftsol4",itau_w,pftsol4)
-
-         CALL histwrite_phy(nid_tra,"psrf1",itau_w,ppsrf1)
-
-         CALL histwrite_phy(nid_tra,"psrf2",itau_w,ppsrf2)
-
-         CALL histwrite_phy(nid_tra,"psrf3",itau_w,ppsrf3)
-
-         CALL histwrite_phy(nid_tra,"psrf4",itau_w,ppsrf4)
-        CALL histwrite_phy(nid_tra,"pplay",itau_w,pplay)
-
-        CALL histwrite_phy(nid_tra,"t",itau_w,t_seri)
-        CALL histwrite_phy(nid_tra,"mfu",itau_w,pmfu)
-        CALL histwrite_phy(nid_tra,"mfd",itau_w,pmfd)
-        CALL histwrite_phy(nid_tra,"en_u",itau_w,pen_u)
-        CALL histwrite_phy(nid_tra,"en_d",itau_w,pen_d)
-        CALL histwrite_phy(nid_tra,"de_d",itau_w,pde_d)
-        CALL histwrite_phy(nid_tra,"de_u",itau_w,pde_u)
-        CALL histwrite_phy(nid_tra,"coefh",itau_w,coefh)
-
-
-c abder
-
-      if (ok_sync) then
-c$OMP MASTER
-        call histsync(nid_tra)
-c$OMP END MASTER
-       endif
-
-       END IF !ecrit_tra>0. .AND. config_inca == 'none'
-
-
-
+#endif
